Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import nat.
Parameter bigop : forall (H:Type), nat.nat -> (nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H.
Parameter bigop_body : forall (H:Type), nat.nat -> (nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H.
Axiom axiom_bigop_O : forall H, connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop (H) nat.O) (bigop_body (H) nat.O).
Definition eq_bigop_O : forall H, leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop (H) nat.O) (bigop_body (H) nat.O) := fun (H:Type) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop (H) nat.O)) (bigop_body (H) nat.O)) ((axiom_bigop_O) (H)).
Definition sym_eq_bigop_O : forall H, leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) nat.O) (bigop (H) nat.O) := fun (H:Type) => ((((leibniz.sym_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop (H) nat.O)) (bigop_body (H) nat.O)) ((eq_bigop_O) (H)).
Axiom axiom_bigop_S : forall H, forall (n:nat.nat), connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop (H) (nat.S n)) (bigop_body (H) (nat.S n)).
Definition eq_bigop_S : forall H, forall (n:nat.nat), leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop (H) (nat.S n)) (bigop_body (H) (nat.S n)) := fun (H:Type) => fun (n:nat.nat) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop (H) (nat.S n))) (bigop_body (H) (nat.S n))) (((axiom_bigop_S) (H)) (n)).
Definition sym_eq_bigop_S : forall H, forall (n:nat.nat), leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) (nat.S n)) (bigop (H) (nat.S n)) := fun (H:Type) => fun (n:nat.nat) => ((((leibniz.sym_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop (H) (nat.S n))) (bigop_body (H) (nat.S n))) (((eq_bigop_S) (H)) (n)).
Axiom axiom_bigop_body_O : forall H, connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) nat.O) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil).
Definition eq_bigop_body_O : forall H, leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) nat.O) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil) := fun (H:Type) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) nat.O)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil)) ((axiom_bigop_body_O) (H)).
Definition sym_eq_bigop_body_O : forall H, leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil) (bigop_body (H) nat.O) := fun (H:Type) => ((((leibniz.sym_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) nat.O)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil)) ((eq_bigop_body_O) (H)).
Axiom axiom_bigop_body_S : forall H, forall (n:nat.nat), connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) (nat.S n)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n)).
Definition eq_bigop_body_S : forall H, forall (n:nat.nat), leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) (nat.S n)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n)) := fun (H:Type) => fun (n:nat.nat) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) (nat.S n))) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n))) (((axiom_bigop_body_S) (H)) (n)).
Definition sym_eq_bigop_body_S : forall H, forall (n:nat.nat), leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n)) (bigop_body (H) (nat.S n)) := fun (H:Type) => fun (n:nat.nat) => ((((leibniz.sym_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) (nat.S n))) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => bool.match_bool_type (H) (op (f n) (bigop (H) n p nil op f)) (bigop (H) n p nil op f) (p n))) (((eq_bigop_body_S) (H)) (n)).
Definition bigop_Strue : forall B, forall (k:nat.nat), forall (p:(nat.nat -> bool.bool)), forall (nil:B), forall (op:(B -> B -> B)), forall (f:(nat.nat -> B)), (logic.eq (bool.bool) (p k) bool.true) -> logic.eq (B) (bigop (B) (nat.S k) (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) (op (f k) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i))) := fun (B:Type) => fun (k:nat.nat) => fun (p:nat.nat -> bool.bool) => fun (nil:B) => fun (op:B -> B -> B) => fun (f:nat.nat -> B) => ((((sym_eq_bigop_S) (B)) (k)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => (logic.eq (bool.bool) (p k) bool.true) -> logic.eq (B) (y (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) (op (f k) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i))))) (((((sym_eq_bigop_body_S) (B)) (k)) (fun (y:((nat.nat -> bool.bool) -> B -> (B -> B -> B) -> (nat.nat -> B) -> B)) => (logic.eq (bool.bool) (p k) bool.true) -> logic.eq (B) (y (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) (op (f k) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i))))) (fun (H:logic.eq (bool.bool) (p k) bool.true) => (((((((logic.eq_ind_r) (bool.bool)) (bool.true)) (fun (x:bool.bool) => logic.eq (B) (bool.match_bool_type (B) (op (f k) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i))) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) x) (op (f k) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i))))) ((((((bool.eq_match_bool_type_true) (B)) (op (f k) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)))) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i))) (fun (y:B) => logic.eq (B) (bool.match_bool_type (B) (op (f k) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i))) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) bool.true) y)) (((logic.refl) (B)) (bool.match_bool_type (B) (op (f k) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i))) (bigop (B) k (fun (i:nat.nat) => p i) nil op (fun (i:nat.nat) => f i)) bool.true)))) (p k)) (H)))).
